
static void init_gauss_fac()
{int64 u,v,u2,s,B; B=ceil(sqrt(PRIME_LIMIT));
 for (u=0;u<PRIME_LIMIT;u++) GAUSS[u].re=0;
 for (u=1;u<B;u+=2)
 {u2=u*u; for (v=0;v<B;v+=2)
  {s=u2+v*v;
   if (s<PRIME_LIMIT && !GAUSS[s].re) {GAUSS[s].re=u; GAUSS[s].im=v;}}}}

static void init_sqrt2_fac()
{int64 u,v,u2,s,B; B=ceil(sqrt(2*PRIME_LIMIT));
 for (u=0;u<PRIME_LIMIT;u++) SQRT2[u].a=0;
 for (u=0;u<B;u++)
 {u2=s=u*u; for (v=0;s>0;v++)
  {s=u2-2*v*v;
   if (s>0 && s<PRIME_LIMIT && !SQRT2[s].a) {SQRT2[s].a=u; SQRT2[s].b=v;}}}}

static bool *IS_PRIME;
static void init_gauss_primes()
{int64 sz,i,c=0;
 IS_PRIME=malloc(PRIME_LIMIT); for (i=0;i<PRIME_LIMIT;i++) IS_PRIME[i]=0;
 sz=(PRIME_LIMIT+100000)*sizeof(gauss);
 printf("Malloc %dmb for GAUSS/SQRT2 each\n",sz>>20);
 GAUSS=malloc(sz); SQRT2=malloc(sz);
 for (c=0;PRIMES[c] && PRIMES[c]<PRIME_LIMIT;c++) IS_PRIME[PRIMES[c]]=1;
 init_gauss_fac(); init_sqrt2_fac();}

/************************************************************************/

void bin_print(uint64 *M,int m,int n)
{int i,j; for (i=0;i<m;i++)
 {for (j=0;j<n;j++) printf("%d",(M[i]&(1ULL<<j))?1:0);printf(" %lld\n",M[i]);}}

#define SWAP(x,y) {x=x^y; y=x^y; x=x^y;}
int dimkerF2(uint64 *M,int m,int n) /* now seems 64 bit safe */
{int i,j,r=0; uint64 f; if (VERBOSE) bin_print(M,m,n);
 for (f=(1ULL<<(n-1));f;f>>=1)
 {for (j=r;j<m;j++)
  {if (M[j]&f)
   {if (j!=r) SWAP(M[j],M[r]);
    for (i=r+1;i<m;i++) if (M[i]&f) M[i]^=M[r]; r++; break;}}} return(m-r);}
